local L = AceLibrary("AceLocale-2.2"):new("xChar")

function xChar:CHAT_MSG_MONSTER_YELL()
	if arg1:lower():find(VICTORY_TEXT0:lower())
	or arg1:lower():find(VICTORY_TEXT1:lower()) then
		self:GetBattlegroundStats()	 
	end
end

function xChar:CHAT_MSG_BG_SYSTEM_NEUTRAL()
	if arg1:lower():find(VICTORY_TEXT0:lower()) 
	or arg1:lower():find(VICTORY_TEXT1:lower()) then
		self:GetBattlegroundStats()	
	end
end

function xChar:GetPVP()
	UploadData.pvp_rank = UnitPVPRank("player")
	UploadData.pvp_hk, UploadData.pvp_highestrank = GetPVPLifetimeStats()
	UploadData.pvp_honor = GetHonorCurrency()
	UploadData.pvp_yhk, UploadData.pvp_ycp = GetPVPYesterdayStats()
end

function xChar:GetBattlegroundStats()
	
	local Battlefield = {}
	
	if L:HasReverseTranslation(GetRealZoneText()) then 
		Battlefield.mapName = L:GetReverseTranslation(GetRealZoneText())
	else
		Battlefield.mapName = L:GetReverseTranslation(GetRealZoneText())
	end
	
	Battlefield.timestamp = date("!%c")
	
	-- 0: Horde/Green Team 1: Alliance/Yellow Team
	Battlefield.winner = GetBattlefieldWinner()
	
	local memberCount = GetNumBattlefieldScores()
	local statCount = GetNumBattlefieldStats()
	
	Battlefield.memberCount = memberCount
	Battlefield.statCount = statCount
	
	local SpecificStatInfo = {}

	for k = 1, statCount do 
		local statName, statIcon, statTooltip = GetBattlefieldStatInfo(k)
		SpecificStatInfo[k] = {}
		SpecificStatInfo[k].name = statName
		SpecificStatInfo[k].icon = statIcon
		SpecificStatInfo[k].tooltip = statTooltip
	end
	
	local Members = {}
	
	for i = 1, memberCount do
		Members[i] = {}
	
		local longname, killingBlows, honorKills, deaths, honorGained, faction, rank, race, _, class, 
		damageDone, healingDone = GetBattlefieldScore(i)
		
		local realm, name = "", ""
		
		if string.find(longname, "-") then
			_, _, name, realm = string.find(longname, "(%a+)\-([%a' ]+)")
		else
			name = longname
			realm = GetRealmName()
		end
		
		Members[i].name = name
		Members[i].realm = realm
		Members[i].killingBlows = killingBlows
		Members[i].honorKills = honorKills
		Members[i].deaths = deaths
		Members[i].honorGained = honorGained
		Members[i].faction = faction
		Members[i].rank = rank
		Members[i].race = race
		Members[i].class = class
		Members[i].damageDone = damageDone
		Members[i].healingDone = healingDone
		
		-- Battlefield specific Data
		
		local SpecificStats = {}
		
		for j = 1, statCount do
			SpecificStats[j] = GetBattlefieldStatData(i, j)			
		end
		
		Members[i].SpecificStats = SpecificStats
		
	end
	
	Battlefield.Members = Members
	Battlefield.SpecificStatInfo = SpecificStatInfo
	
	if not UploadData.Battlefields then UploadData.Battlefields = {} end
	table.insert(UploadData.Battlefields, Battlefield)
end


